/* /////////////////////////////////////////////////////////////////////////////
 * File:        shared_ptr_test.cpp
 *
 * Purpose:     Implementation file for the shared_ptr_test project.
 *
 * Created:     14th September 2004
 * Updated:     27th June 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>
#include <stlsoft/shared_ptr.hpp>

/* Standard C Header Files */
#include <windows.h>

/* Standard C++ Header Files */
#include <exception>
#include <iostream>

#ifdef __WATCOMC__
namespace std
{
	using ::exception;
}
#else /* ? compiler */
using std::cerr;
using std::cin;
using std::cout;
using std::ostream;
#endif /* compiler */
using std::cout;
using std::endl;

/* /////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

class Thing
{
public:
	Thing()
	{
		cout << "Thing::Thing(" << this << ")" << endl;
	}
	~Thing()
	{
		cout << "Thing::~Thing(" << this << ")" << endl;
	}
};

#ifndef __WATCOMC__
ostream &operator <<(ostream &stm, Thing const &thing)
{
	stm << &thing;

	return stm;
}
#endif /* compiler */

/* ////////////////////////////////////////////////////////////////////////// */

int main(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	cout << "shared_ptr_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;
#endif /* debug */

	/* . */
#if 0
	{
		typedef	stlsoft_ns_qual(shared_ptr)<int>	sp_int_t;

		sp_int_t	p;
#ifdef __WATCOMC__
#else /* ? compiler */
		sp_int_t	p1(new int(10));
		sp_int_t	p2(p1);

		cout << p1 << endl;
		cout << p2 << endl;

		sp_int_t	p3;

		p3 = p1;

		p3.close();
		p1.close();
		p2.close();
#endif /* compiler */
	}
#endif /* 0 */

	{
		typedef	stlsoft_ns_qual(shared_ptr)<Thing>	sp_Thing_t;

		sp_Thing_t	p0;
		sp_Thing_t	p1(p0);
		sp_Thing_t	p2(new Thing());

		sp_Thing_t	p4;

		p4 = p2;

		p0.close();
		p1.close();
		p2.close();
	}

    return 0;
}

/* ////////////////////////////////////////////////////////////////////////// */
