/* /////////////////////////////////////////////////////////////////////////////
 * File:        slice_string_test.cpp
 *
 * Purpose:     Implementation file for the slice_string_test project.
 *
 * Created:     18th February 2004
 * Updated:     20th October 2004
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright (C) 1999-2004, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2004
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software.
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage.
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission.
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>
#include <stlsoft_string_tokeniser.h>
#include <stlsoft/slice_string.hpp>

/* Standard C Header Files */

/* Standard C++ Header Files */
#include <iostream>

using std::cerr;
using std::cin;
using std::cout;
using std::endl;

/* ////////////////////////////////////////////////////////////////////////// */

int main_(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	cout << "slice_string_test: " << __STLSOFT_COMPILER_LABEL_STRING << endl;
#endif /* debug */

	/* . */
	typedef stlsoft::basic_slice_string<char>	string_t;

	string_t		s1;
	string_t		s2;
	string_t		s3("This is a literal string");
	string_t		s4(s3);
	string_t		s5(s3, 5);
	string_t		s6(s3, 5, 8);

	stlsoft_assert(s1 == s2);
	stlsoft_assert(s3 == s4);

	cout << "s1: " << s1 << endl;
	cout << "s2: " << s2 << endl;
	cout << "s3: " << s3 << endl;
	cout << "s4: " << s4 << endl;
	cout << "s5: " << s5 << endl;
	cout << "s6: " << s6 << endl;

	{ // Now check whether it works with the tokeniser

		typedef	stlsoft::string_tokeniser<string_t, char>	tokeniser_t;

		tokeniser_t					tokens(";;T:\\Program Files\\Microsoft Visual Studio .NET Whidbey\\SDK\\v1.2\\include\\;T:\\Program Files\\Microsoft Visual Studio .NET Whidbey\\SDK\\v1.2\\include\\;P:\\Program Files\\Microsoft Visual Studio .NET 2003\\SDK\\v1.1\\include\\;P:\\Program Files\\Microsoft.NET\\FrameworkSDK\\include\\;P:\\Program Files\\Intel\\Compiler70\\IA32\\Include;P:\\Program Files\\Intel\\Compiler60\\IA32\\Include;P:\\SDKs\\Microsoft SDK\\Include\\.;P:\\Program Files\\Codeplay\\includePC;", ';');
		tokeniser_t::const_iterator	b = tokens.begin();
		tokeniser_t::const_iterator	e = tokens.end();

#if 0
		for(; b != e; ++b)
		{
			cout << *b << endl;
		}
#else /* ? 0 */
		std::copy(tokens.begin(), tokens.end(), std::ostream_iterator<string_t>(cout, "\n"));
#endif /* 0 */

//		printf("Now use the FILE_inserter<>\n");
//		std::copy(tokens.begin(), tokens.end(), stlsoft::FILE_inserter<string_t>(stdout, "\n"));
	}

    return 0;
}

int main(int argc, char *argv[])
{
	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		cerr << "Unhandled error: " << x.what() << endl;
	}
	catch(...)
	{
		cerr << "Unhandled unknown error" << endl;
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
