/* /////////////////////////////////////////////////////////////////////////////
 * File:        clipboard_scope_test.cpp
 *
 * Purpose:     Implementation file for the clipboard_scope_test project.
 *
 * Created:     26th May 2005
 * Updated:     26th May 2005
 *
 * Status:      Wizard-generated
 *
 * License:     (Licensed under the Synesis Software Open License)
 *
 *              Copyright 1999-2005, Synesis Software Pty Ltd.
 *              All rights reserved.
 *
 *              www:        http://www.synesis.com.au/software
 *
 *              email:      software@synesis.com.au
 *
 *              This source code is placed into the public domain 2005
 *              by Synesis Software Pty Ltd. There are no restrictions
 *              whatsoever to your use of the software. 
 *
 *              This source code is provided by Synesis Software Pty Ltd "as is"
 *              and any warranties, whether expressed or implied, including, but
 *              not limited to, the implied warranties of merchantability and
 *              fitness for a particular purpose are disclaimed. In no event
 *              shall the Synesis Software Pty Ltd be liable for any direct,
 *              indirect, incidental, special, exemplary, or consequential
 *              damages (including, but not limited to, procurement of
 *              substitute goods or services; loss of use, data, or profits; or
 *              business interruption) however caused and on any theory of
 *              liability, whether in contract, strict liability, or tort
 *              (including negligence or otherwise) arising in any way out of
 *              the use of this software, even if advised of the possibility of
 *              such damage. 
 *
 *              Neither the name of Synesis Software Pty Ltd nor the names of
 *              any subdivisions, employees or agents of Synesis Software Pty
 *              Ltd, nor the names of any other contributors to this software
 *              may be used to endorse or promote products derived from this
 *              software without specific prior written permission. 
 *
 * ////////////////////////////////////////////////////////////////////////// */

/* STLSoft Header Files */
#include <stlsoft.h>

/* WinSTL Header Files */
#include <winstl.h>
#include <winstl/clipboard_scope.hpp>

/* Standard C++ Header Files */
#include <exception>
#include <iostream>
#include <stdexcept>

using std::cout;
using std::cerr;
using std::endl;
using std::wcout;
using std::wcerr;

#ifdef __WATCOMC__
namespace std
{
	using ::exception;
}
#endif /* __WATCOMC__ */

/* Standard C Header Files */
#include <stdio.h>

/* /////////////////////////////////////////////////////////////////////////////
 * Classes
 */


/* ////////////////////////////////////////////////////////////////////////// */

static int main_(int /* argc */, char ** /*argv*/)
{
#if 0
	::Sleep(100000);
#endif /* 0 */

#if defined(_DEBUG) || \
    defined(__SYNSOFT_DBS_DEBUG)
	puts("clipboard_scope_test: " __STLSOFT_COMPILER_LABEL_STRING);
#endif /* debug */

	/* . */
	{
		winstl::clipboard_scope	cb;

		cb.set_data("Hello, Dr!");
	}

	{
		winstl::clipboard_scope	cb;

		if(cb.is_fmt_available(CF_TEXT))
		{
			cout << (char*)cb.get_data(CF_TEXT) << endl;
		}
		if(cb.is_fmt_available(CF_UNICODETEXT))
		{
			wcout << (wchar_t*)cb.get_data(CF_UNICODETEXT) << endl;
		}
	}

    return 0;
}

int main(int argc, char *argv[])
{
	try
	{
		return main_(argc, argv);
	}
	catch(std::exception &x)
	{
		fprintf(stderr, "Unhandled error: %s\n", x.what());
	}
	catch(...)
	{
		fprintf(stderr, "Unhandled unknown error\n");
	}

	return EXIT_FAILURE;
}

/* ////////////////////////////////////////////////////////////////////////// */
