/* /////////////////////////////////////////////////////////////////////////////
 * File:        Window_access_test.cpp
 *
 * Purpose:     Implementation file for the window_access_test project.
 *
 * Created:     10th December 2002
 * Updated:     30th May 2004
 * Author:      Synesis Software (Pty) Ltd (C) 2002. All rights reserved.
 *              (www.synesis-group.com/software).
 *
 * Status:      Third-party
 *
 * Copyright:   Synesis Software (Pty) Ltd provides the source code contained in
 *              this file/document free-of-charge according to the following
 *              conditions:
 *
 *              (i) No warranty, expressed or implied, is given as to the
 *              correctness or efficiency of the code.
 *              (ii) No part of this code may be modified or copied, by whatever
 *              means without including a copy of this notice in its entirety
 *              (this means the all content between the <<START:>> and <<:END>>
 *              tokens inclusive, including, and not limited to, purpose, date
 *              of creation, date of last update, authorship, address, copyright
 *              and status).
 *              (iii) This code, in whole or part, remains the property of
 *              Synesis Software (Pty) Ltd, whether incorporated as-is, or in
 *              modified form.
 *
 * ////////////////////////////////////////////////////////////////////////// */


/* ////////////////////////////////////////////////////////////////////////////
 * Includes
 */

#include <windows.h>

#include "resource.h"

/* ////////////////////////////////////////////////////////////////////////////
 * Namespace
 */

/* ////////////////////////////////////////////////////////////////////////////
 * Constants & definitions
 */

/* ////////////////////////////////////////////////////////////////////////////
 * Statics & globals
 */

/* ////////////////////////////////////////////////////////////////////////////
 * Forward declarations
 */

BOOL CALLBACK Window_access_testDialogProc(   HWND    hwnd,
                                            UINT    uMsg,
                                            WPARAM  wParam,
                                            LPARAM  lParam);

/* ////////////////////////////////////////////////////////////////////////////
 * Functions
 */

int WINAPI WinMain( HINSTANCE   hinst,
                    HINSTANCE   /* hinstPrev */,
                    LPSTR       lpszCmdLine,
                    int         nCmdShow)
{
    ::DialogBoxParam(hinst, MAKEINTRESOURCE(IDD_WINDOW_ACCESS_TEST), NULL, Window_access_testDialogProc, 0);

    return 0;
}


static BOOL Window_access_test_OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    return false;
}

static BOOL Window_access_test_OnCommand(HWND hwnd, int code, int idCtrl, HWND hwndCtrl)
{
    BOOL    bRet    =   false;

    switch(idCtrl)
    {
        case    IDOK:
			/* Fall through */
        case    IDCANCEL:
            ::EndDialog(hwnd, idCtrl);
            bRet = true;
            break;
    }

    return bRet;
}



BOOL CALLBACK Window_access_testDialogProc(   HWND    hwnd,
                                            UINT    uMsg,
                                            WPARAM  wParam,
                                            LPARAM  lParam)
{
    BOOL    bRet    =   false;

    switch(uMsg)
    {
        case    WM_INITDIALOG:
            bRet = Window_access_test_OnInitDialog(hwnd, (HWND)wParam, lParam);
            break;
        case    WM_COMMAND:
            bRet = Window_access_test_OnCommand(hwnd, (int)HIWORD(wParam), (int) LOWORD(wParam), (HWND)lParam);
            break;
    }

    return bRet;
}

/* ////////////////////////////////////////////////////////////////////////// */
